﻿using System;
using System.IO;
using System.Text;

namespace PinpadDemo
{
    public static class StreamHelper
    {
        public static byte ReadByte(Stream stream)
        {
            int b = stream.ReadByte();

            if (b < 0) 
            {
                throw new IOException("End of stream");
            }

            return (byte)b;
        }

        public static short ReadInt16(Stream stream) 
        {
            short value = (short)(ReadByte(stream) << 8);
            value += ReadByte(stream);
            return value;
        }

        public static int ReadInt32(Stream stream)
        {
            int value = ReadByte(stream) << 24;
            value += ReadByte(stream) << 16;
            value += ReadByte(stream) << 8;
            value += ReadByte(stream);
            return value;
        }

        public static byte[] ReadData(Stream stream, long size)
        {
            byte[] data = new byte[size];

            for (int i = 0; i < size; i++)
            {
                data[i] = ReadByte(stream);
            }

            return data;
        }
    }
}
